<?php
//
// +---------------------------------------------------------------------------+
// | nmoxgooglerank Geeklog Plugin 1.0                                       |
// +---------------------------------------------------------------------------+
// | function.inc                                                              |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2007 by nmox                                                |
// |                                                                           |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// +---------------------------------------------------------------------------+
/**
* Language file Include
*/
$langfile = $_CONF['path'] . 'plugins/nmoxgooglerank/language/' . $_CONF['language'] . '.php';
if (file_exists ($langfile))
{
	include_once ($langfile);
}
else
{
	include_once ($_CONF['path'] . 'plugins/nmoxgooglerank/language/english.php');
}

require_once ($_CONF['path'] . 'plugins/nmoxgooglerank/config.php');

// +---------------------------------------------------------------------------+
// | Geeklog Plugin API Implementations                                        |
// +---------------------------------------------------------------------------+

function plugin_chkVersion_nmoxgooglerank() {
	global $_NMOXGOOGLERANK;

	return $_NMOXGOOGLERANK['version'];
}

/**
* Returns the items for this plugin that should appear on the main menu
*
* NOTE: this MUST return the url/value pairs in the following format
* $<arrayname>[<label>] = <url>
*
* Universal Plugin:  Uncomment and fill in variables;
* 
* @return    array   Associative array of menu items to be added to menu
*
*/
function plugin_getmenuitems_nmoxgooglerank()
{
}

/**
* Check to see if this Plugin uses comments
*
* Geeklog is checking to see if this plugin supports comments, tell it no!
* NOTE: to support comments you must use the same date/time based ID for your
* widget.  In other words, to make primary keys for your plugin you should call
* makesid().  Comments are keyed off of that...it is a limitation on how geeklog
* does comments.
*
* @return   boolean true or false
*
*/
function plugin_commentsupport_nmoxgooglerank()
{
	return false;
}

/**
* Shows the statistics for the plugin on stats.php.  If
* $showsitestats is 1 then we are to only print the overall stats in the 'site
* statistics' box otherwise we show the detailed stats for the plugin
*
* Universal Plugin:  Modify/uncomment use it
*
* @param    int showsitestate   Flag to let us know which stats to get
* @return   string  returns formatted HTML to insert in stats page
*
*/
function plugin_showstats_nmoxgooglerank($showsitestats)
{
	$retval = '';
	return $retval;
}

function plugin_upgrade_nmoxgooglerank ()
{
    global $_TABLES, $_NMOXGOOGLERANK;

    $v = DB_getItem ($_TABLES['plugins'], 'pi_version', "pi_name = 'nmoxgooglerank'");

    if ($v != $_NMOXGOOGLERANK['version']) {
        // update version numbers
        DB_query ("UPDATE {$_TABLES['plugins']} SET pi_version = '{$_NMOXGOOGLERANK['version']}', pi_gl_version = '1.4.1' WHERE pi_name = 'nmoxgooglerank'");

        // check if version number was updated successfully
        $v = DB_getItem ($_TABLES['plugins'], 'pi_version', "pi_name = 'spamx'");
    }

    if ($v == $_NMOXGOOGLERANK['version']) {
        return true;
    }

    return true;
}

/**
* Removes the datastructures for this plugin from the Geeklog database.
* This routine will get called from the Plugin install program if user select De-Install or if Delete is used in the Plugin Editor.
* The Plugin Installer will also call this routine upon and install error to remove anything it has created.
* The Plugin installer will pass the optional parameter which will then double check that plugin has first been disabled. 
* 
* For this plugin, this routine will also remove the Block definition.
* 
* Returns True if all Plugin related data is removed without error
*
* @param    string   $installCheck     Defult is blank but if set, check if plugin is disabled first
* 
* @return   boolean True if successful false otherwise
*
*/  
function plugin_uninstall_nmoxgooglerank($installCheck = '')
{
	global $_TABLES, $LANG_NMOXGOOGLERANK,$_CONF;

	$pi_name  = 'nmoxgooglerank';


	$grp_id = DB_getItem($_TABLES['vars'], 'value', "name = '{$pi_name}_admin'");
	DB_delete($_TABLES['plugins'],'pi_name','nmoxgooglerank');
	DB_query("DELETE FROM {$_TABLES['group_assignments']} WHERE ug_main_grp_id = $grp_id",1);
	$FEATURES = array ('nmoxgooglerank.edit','nmoxgooglerank.user');
	foreach ($FEATURES as $feature) {
		$feat_id = DB_getItem($_TABLES['features'], 'ft_id', "ft_name = '$feature'");
		DB_query("DELETE FROM {$_TABLES['access']} WHERE acc_ft_id = $feat_id",1);
		DB_query("DELETE FROM {$_TABLES['features']} WHERE ft_id = $feat_id",1);
	}
	DB_query("DELETE FROM {$_TABLES['vars']} WHERE name = '{$pi_name}_admin'");
	DB_query("DELETE FROM {$_TABLES['groups']} WHERE grp_id = $grp_id",1);
    DB_query("DELETE FROM {$_TABLES['blocks']} WHERE name='nmoxgooglerank'",1);

	return true;
}

function plugin_getadminoption_nmoxgooglerank(){
	/*
	global $_CONF, $_NMOXGOOGLERANK, $_TABLES;

	if (SEC_hasRights ('nmoxgooglerank.edit', 'OR')) {
		return array ($_NMOXGOOGLERANK['nmoxgooglerank'], $_CONF['site_admin_url'] . '/plugins/nmoxgooglerank/index.php');
	}
	*/
}

function phpblock_nmoxgooglerank() {
	global $_CONF;
	$gpr = new pageRank();
	$gpr->printrank(COM_buildURL($_CONF["site_url"].$_SERVER["REQUEST_URI"]));
	//display image
	return "<div class='block-box' align='right'>".$gpr->get_pr()."</div>";
}

//
define('GOOGLE_MAGIC', 0xE6359A60);
class pageRank{
var $pr; 
 function zeroFill($a, $b){
 $z = hexdec(80000000);
  if ($z & $a){
   $a = ($a>>1);
   $a &= (~$z);
   $a |= 0x40000000;
   $a = ($a>>($b-1));
  }else{
   $a = ($a>>$b);
  }
 return $a;
 } 
 
 function mix($a,$b,$c) {
   $a -= $b; $a -= $c; $a ^= ($this->zeroFill($c,13));
   $b -= $c; $b -= $a; $b ^= ($a<<8);
   $c -= $a; $c -= $b; $c ^= ($this->zeroFill($b,13));
   $a -= $b; $a -= $c; $a ^= ($this->zeroFill($c,12));
   $b -= $c; $b -= $a; $b ^= ($a<<16);
   $c -= $a; $c -= $b; $c ^= ($this->zeroFill($b,5));
   $a -= $b; $a -= $c; $a ^= ($this->zeroFill($c,3));
   $b -= $c; $b -= $a; $b ^= ($a<<10);
   $c -= $a; $c -= $b; $c ^= ($this->zeroFill($b,15));
   return array($a,$b,$c);
 }
 
 function GoogleCH($url, $length=null, $init=GOOGLE_MAGIC) {
  if(is_null($length)) {
   $length = sizeof($url);
  }
  $a = $b = 0x9E3779B9;
  $c = $init;
  $k = 0;
  $len = $length;
  while($len >= 12) {
   $a += ($url[$k+0] +($url[$k+1]<<8) +($url[$k+2]<<16) +($url[$k+3]<<24));
   $b += ($url[$k+4] +($url[$k+5]<<8) +($url[$k+6]<<16) +($url[$k+7]<<24));
   $c += ($url[$k+8] +($url[$k+9]<<8) +($url[$k+10]<<16)+($url[$k+11]<<24));
   $mix = $this->mix($a,$b,$c);
   $a = $mix[0]; $b = $mix[1]; $c = $mix[2];
   $k += 12;
   $len -= 12;
  }
  $c += $length;
  switch($len){
   case 11: $c+=($url[$k+10]<<24);
   case 10: $c+=($url[$k+9]<<16);
   case 9 : $c+=($url[$k+8]<<8);
   /* the first byte of c is reserved for the length */
   case 8 : $b+=($url[$k+7]<<24);
   case 7 : $b+=($url[$k+6]<<16);
   case 6 : $b+=($url[$k+5]<<8);
   case 5 : $b+=($url[$k+4]);
   case 4 : $a+=($url[$k+3]<<24);
   case 3 : $a+=($url[$k+2]<<16);
   case 2 : $a+=($url[$k+1]<<8);
   case 1 : $a+=($url[$k+0]);
  }
  $mix = $this->mix($a,$b,$c);
 /* report the result */
 return $mix[2];
 }
 
 //converts a string into an array of integers containing the numeric value of the char
 
 function strord($string) {
  for($i=0;$i<strlen($string);$i++) {
   $result[$i] = ord($string{$i});
  }
 return $result;
 }
 
 function printrank($url){
  $ch = "6".$this->GoogleCH($this->strord("info:" . $url));
  
  $fp = fsockopen("www.google.com", 80, $errno, $errstr, 30);
  if (!$fp) {
     echo "$errstr ($errno)<br />\n";
  } else {
     $out = "GET /search?client=navclient-auto&ch=" . $ch .  "&features=Rank&q=info:" . $url . " HTTP/1.1\r\n" ;
     $out .= "Host: www.google.com\r\n" ;
     $out .= "Connection: Close\r\n\r\n" ; 
     fwrite($fp, $out);
     while (!feof($fp)) {
       $data = fgets($fp, 128);
       $pos = strpos($data, "Rank_");
         if($pos === false){
         }else{
           $pagerank = substr($data, $pos + 9);
           $this->pr_image($pagerank);
         }
     }
     fclose($fp);
  }
 }
//display pagerank image. Create your own or download images I made for this script. If you make your own make sure to call them pr0.gif, pr1.gif, pr2.gif etc.
 function pr_image($pagerank){
	global $_CONF;
  if($pagerank == 0){
   $this->pr = "<img src=\"".$_CONF["site_url"]."/nmoxgooglerank/images/pr0.gif\" alt=\"PageRank " .$pagerank. " out of 10\" title=\"PageRank " .$pagerank. " out of 10\">" ;
   }elseif($pagerank == 1){
   $this->pr = "<img src=\"".$_CONF["site_url"]."/nmoxgooglerank/images/pr1.gif\" alt=\"PageRank " .$pagerank. " out of 10\" title=\"PageRank " .$pagerank. " out of 10\">" ;
   }elseif($pagerank == 2){
   $this->pr = "<img src=\"".$_CONF["site_url"]."/nmoxgooglerank/images/pr2.gif\" alt=\"PageRank " .$pagerank. " out of 10\" title=\"PageRank " .$pagerank. " out of 10\">" ;
   }elseif($pagerank == 3){
   $this->pr = "<img src=\"".$_CONF["site_url"]."/nmoxgooglerank/images/pr3.gif\" alt=\"PageRank " .$pagerank. " out of 10\" title=\"PageRank " .$pagerank. " out of 10\">" ;
   }elseif($pagerank == 4){
   $this->pr = "<img src=\"".$_CONF["site_url"]."/nmoxgooglerank/images/pr4.gif\" alt=\"PageRank " .$pagerank. " out of 10\" title=\"PageRank " .$pagerank. " out of 10\">" ;
   }elseif($pagerank == 5){
   $this->pr = "<img src=\"".$_CONF["site_url"]."/nmoxgooglerank/images/pr5.gif\" alt=\"PageRank " .$pagerank. " out of 10\" title=\"PageRank " .$pagerank. " out of 10\">" ;
   }elseif($pagerank == 6){
   $this->pr = "<img src=\"".$_CONF["site_url"]."/nmoxgooglerank/images/pr6.gif\" alt=\"PageRank " .$pagerank. " out of 10\" title=\"PageRank " .$pagerank. " out of 10\">" ;
   }elseif($pagerank == 7){
   $this->pr = "<img src=\"".$_CONF["site_url"]."/nmoxgooglerank/images/pr7.gif\" alt=\"PageRank " .$pagerank. " out of 10\" title=\"PageRank " .$pagerank. " out of 10\">" ;
   }elseif($pagerank == 8){
   $this->pr = "<img src=\"".$_CONF["site_url"]."/nmoxgooglerank/images/pr8.gif\" alt=\"PageRank " .$pagerank. " out of 10\" title=\"PageRank " .$pagerank. " out of 10\">" ;
   }elseif($pagerank == 9){
   $this->pr = "<img src=\"".$_CONF["site_url"]."/nmoxgooglerank/images/pr9.gif\" alt=\"PageRank " .$pagerank. " out of 10\" title=\"PageRank " .$pagerank. " out of 10\">" ;
   }else{
   $this->pr = "<img src=\"".$_CONF["site_url"]."/nmoxgooglerank/images/pr10.gif\" alt=\"PageRank " .$pagerank. " out of 10\" title=\"PageRank " .$pagerank. " out of 10\">" ;
  }
 }
 function get_pr(){
  return $this->pr;
 }
}
?>
