<?php
//
// for cellular phones.
//

// host charset.
$__HOSTCHARSET = 'UTF-8';

// for session control on terminals has no cookie.
$__MBSID = "";

// UA is cellular or not.
function isCellular()
{
  $agent = $_SERVER["HTTP_USER_AGENT"];
  return ($agent == "" ||
	  //preg_match("/^Mozilla\/5\.0/i", $agent) || // Firefox (for debug)
	  preg_match("/^(DoCoMo\/1|DoCoMo\/2)\.0/i", $agent) ||
	  preg_match("/^(J\-PHONE|Vodafone|MOT\-[CV]|Vemulator)/i", $agent) ||
	  preg_match("/^(UP\.Browser|KDDI\-)/i", $agent) ||
	  preg_match("/DDIPOCKET/i", $agent));
}

// output handler for cellular phones.
function CUSTOM_output_handler($content, $status)
{
  global $__MBSID;

  $search =
    array(// cut "div"
	  '@<[ 	]*div[^>]*?>@si',
	  '@<[ 	]*/div[^>]*?>@si',
	  // cut script
	  '@<script[^>]*?>.*?</script>@si',
	  // cut "table"
	  '@<[ 	]*table[^>]*?>@si',
	  '@<[ 	]*/table[^>]*?>@si',
	  '@<[ ]*thead[^>]*?>@si',
	  '@<[ ]*/thead[^>]*?>@si',
	  '@<[ ]*tbody[^>]*?>@si',
	  '@<[ ]*/tbody[^>]*?>@si',
	  '@<[ ]*tfoot[^>]*?>@si',
	  '@<[ ]*/tfoot[^>]*?>@si',
	  '@<[ 	]*tr[^>]*?>@si',
	  '@<[ 	]*/tr[^>]*?>@si',
	  '@<[ 	]*th[^>]*?>@si',
	  '@<[ 	]*/th[^>]*?>@si',
	  '@<[ 	]*td[^>]*?>@si',
	  '@<[ 	]*/td[^>]*?>@si',
	  // cut style
	  '@style="[^"].*?"@i',
	  // cut class
	  '@class="[^"].*?"@i',
	  // cut embed
	  '@<embed[^>]*?></embed>@si',
	  // images on articles to link.
	  '@(<img width=.*? src="http://.*?)(images/articles/.*?\.jpg).*?>@i',
	  // topic icon
	  '@(<img .+?src=.+?/images/topics/.+? alt=")(.+?)" [^>]*?>@i',
          // charset
          '@charset=' . $__HOSTCHARSET . '@i',
	  // for vodafone(only japan?).
	  // parameters named 'pid', 'sid', or 'uid' are treated incorrectly
	  // by vodafone(jp)'s access point.
	  // so, URL-encode these parameters.
	  '@pid=@i',
	  '@sid=@i',
	  '@uid=@i',
	  // for phones can't treat ' />' xhtml notation
	  '@ */>@i',
	  );

  $replace=
    array(// cut "div"
	  '',
	  '<br>',
	  // cut script
	  '',
	  // cut "table"
	  '',//<table>
	  '',//</table>
	  '',//<thead>
	  '',//</thead>
	  '',//<tbody>
	  '',//</tbody>
	  '',//<tfoot>
	  '',//</tfoot>
	  '',//<tr>
	  '<br>',//<//tr>
	  '',//<th>
	  '&nbsp;',//</th>
	  '',//<td>
	  '&nbsp;',//</td>
	  // cut style
	  '',
	  // cut class
	  '',
	  // cut embed
	  '',
	  // images on articles to link.
	  '<a href="cellimage.php?image=\$2">Image</a>',
	  // topic icon
	  '$2',
          // charset
          'charset="Shift_JIS"',
	  // for vodafone(only japan?).
	  // parameters named 'pid', 'sid', or 'uid' are treated incorrectly
	  // by vodafone(jp)'s access point.
	  // so, URL-encode these parameters.
	  '%70%69%64=',//pid
	  '%73%69%64=',//sid
	  '%75%69%64=',//uid
	  '>',
	  );
  $content = preg_replace($search, $replace, $content);
  if($__MBSID != "") {
    $content = mobile_session($content);
  }
  return mb_output_handler($content, $status);
}

function mobile_session($content) {
  global $__MBSID;

  if($__MBSID != "") {
    $search = array('@(<a[ 	]+.*?href="' . $_CONF['site_url'] . '[^\"\?]*?)"@i',
		    '@(<a[ 	]+.*?href="' . $_CONF['site_url'] . '(?:\?|[^\"])*?)"@i',
		    '@(<form[ 	]+action="' . $_CONF['site_url'] . '[^\"\?]*?)"@i',
		    '@(<form[ 	]+action="' . $_CONF['site_url'] . '(?:\?|[^\"])*?)"@i',
		    );
    $replace = array('$1' . '?mbsid=' . $__MBSID . '"',
		     '$1' . '&mbsid=' . $__MBSID . '"',
		     '$1'. '?mbsid=' . $__MBSID . '"',
		     '$1'. '&mbsid=' . $__MBSID . '"',
		     );

    return preg_replace($search, $replace, $content);
  } else {
    return $content;
  }
}

// i-mode and many cellulars can't handle '<meta http-equiv="refresh"...
// so, must hack COM_refresh in lib-common.php.
function CUSTOM_refresh($url)
{
  global $LANG05;
  if(isCellular()) {
    //header("Location: $url\n\n");
    //return "";
    return "<html><head></head><body><a href=\"$url\">$LANG05[5]</a></body></html>\n";
  } else {
    return "<html><head><meta http-equiv=\"refresh\" content=\"0; URL=$url\"></head></html>\n";
  }
}

// convert input to host charset.
function prepare_input(&$array) {
  reset($array);
  while (list($key, $val) = each($array)) {
    // bug on SJIS conversion?
    $val = preg_replace("#".preg_quote("\x95\x5c\x5c")."#", "\x95\x5c", $val);

    $array[$key] = mb_convert_encoding($val, $__HOSTCHARSET,
    				       mb_detect_encoding($val, "SJIS,UTF-8,EUC-JP,JIS"));
  }
  reset($array);
}

// check user agent.
if(isCellular()) {
  // use keitai theme: no tables.
  $_CONF['theme'] = '.mobile';
  $_POST['usetheme'] = ".mobile";
  $_USER['theme'] = ".mobile";
  //
  $_CONF['limitnews'] = 3;
  $_CONF['advanced_editor'] = false;
  $CONF_FORUM_MOBILE['show_topics_perpage'] = "5";
  $CONF_FORUM_MOBILE['show_posts_perpage'] = "5";
  $CONF_FORUM_MOBILE['show_messages_perpage'] = "5";
  $CONF_FORUM_MOBILE['show_searches_perpage'] = "5";
  $CONF_FORUM_MOBILE['use_autorefresh'] = "0";
  // shorten messages.
  $_CONF['date'] = ' %Y/%m/%d %I:%M %p';
  $LANG12[9] = "";
  $LANG12[19] = "";

  // convert encoding on input.
  prepare_input($_POST);
  prepare_input($_GET);
  prepare_input($_REQUEST);

  // output to shift jis.
  ini_set('mbstring.internal_encoding', $__HOSTCHARSET);
  ini_set('mbstring.http_output', 'SJIS');
  ini_set('mbstring.http_input', 'SJIS');
  ob_start('CUSTOM_output_handler');
}
?>