<?php 
/*
 * FCKeditor - The text editor for internet
 * Copyright (C) 2003-2006 Frederico Caldeira Knabben
 * 
 * Licensed under the terms of the GNU Lesser General Public License:
 * 		http://www.opensource.org/licenses/lgpl-license.php
 * 
 * For further information visit:
 * 		http://www.fckeditor.net/
 * 
 * "Support Open Source software. What about a donation today?"
 * 
 * File Name: upload.php
 * 	This is the "File Uploader" for PHP.
 * 
 * File Authors:
 * 		Frederico Caldeira Knabben (fredck@fckeditor.net)
 */

require('config.php') ;
require('util.php') ;

function calcSizefactor ($width, $height)
{	global $_CONF;

	$maxImageWidth = $_CONF['max_image_width'];
	$maxImageHeight = $_CONF['max_image_height'];
       if (($width > $maxImageWidth) ||
                ($height > $maxImageHeight)) {
            if (($width > $maxImageWidth) && ($width > $height)) {
                $sizefactor = (double) ($maxImageWidth / $width);
            } else {
                $sizefactor = (double) ($maxImageHeight / $height);
            }
        } else {
            $sizefactor = 1.0;
        }

        return $sizefactor;
}

// This is the function that sends the results of the uploading process.
function SendResults( $errorNumber, $fileUrl = '', $fileName = '', $customMsg = '' )
{
	echo '<script type="text/javascript">' ;
	echo 'window.parent.OnUploadCompleted(' . $errorNumber . ',"' . str_replace( '"', '\\"', $fileUrl ) . '","' . str_replace( '"', '\\"', $fileName ) . '", "' . str_replace( '"', '\\"', $customMsg ) . '") ;' ;
	echo '</script>' ;
	exit ;
}

// Check if this uploader has been enabled.
if ( !$Config['Enabled'] )
	SendResults( '1', '', '', 'This file uploader is disabled. Please check the "editor/filemanager/upload/php/config.php" file' ) ;

// Check if the file has been correctly uploaded.
if ( !isset( $_FILES['NewFile'] ) || is_null( $_FILES['NewFile']['tmp_name'] ) || $_FILES['NewFile']['name'] == '' )
	SendResults( '202' ) ;

// Get the posted file.
$oFile = $_FILES['NewFile'] ;

//@@@@@@@@@@ NAKANISHI LIMIT SIZE SET
$sFileSize = $_FILES['NewFile']['size'] ;
if ($sFileSize > $_CONF['max_image_size'])
    SendResults( 1, '', '', 'Image Size is TooBIG' ) ;
	
// Get the uploaded file name extension.
$sFileName = $oFile['name'] ;

// Replace dots in the name with underscores (only one dot can be there... security issue).
if ( $Config['ForceSingleExtension'] )
	$sFileName = preg_replace( '/\\.(?![^.]*$)/', '_', $sFileName ) ;

$sOriginalFileName = $sFileName ;

// Get the extension.
$sExtension = substr( $sFileName, ( strrpos($sFileName, '.') + 1 ) ) ;
$sExtension = strtolower( $sExtension ) ;

// The the file type (from the QueryString, by default 'File').
$sType = isset( $_GET['Type'] ) ? $_GET['Type'] : 'File' ;

// Check if it is an allowed type.
if ( !in_array( $sType, array('File','Image','Flash','Media') ) )
    SendResults( 1, '', '', 'Invalid type specified' ) ;

// Get the allowed and denied extensions arrays.
$arAllowed	= $Config['AllowedExtensions'][$sType] ;
$arDenied	= $Config['DeniedExtensions'][$sType] ;

// Check if it is an allowed extension.
if ( ( count($arAllowed) > 0 && !in_array( $sExtension, $arAllowed ) ) || ( count($arDenied) > 0 && in_array( $sExtension, $arDenied ) ) )
	SendResults( '202' ) ;

$sErrorNumber	= '0' ;
$sFileUrl		= '' ;

// Initializes the counter used to rename the file, if another one with the same name already exists.
$iCounter = 0 ;

// The the target directory.
if ( isset( $Config['UserFilesAbsolutePath'] ) && strlen( $Config['UserFilesAbsolutePath'] ) > 0 )
	$sServerDir = $Config['UserFilesAbsolutePath'] ;
else 
	$sServerDir = GetRootPath() . $Config["UserFilesPath"] ;

//ե̾ǡ
$sBasename = $_USER['uid'] . '_' . date('Ymd_Hi');
$sFileName = $sBasename . '.' . $sExtension;
while ( true )
{
	// Compose the file path.
	// Geeklog Japanese changed by Tofuya
	// $sFilePath = $sServerDir . $sFileName ;
	// Compose the file path.@@@@@@@@@@ 桼IDե̾ɲä
	$sFilePath = $sServerDir .'Image/'. $sFileName ;

	COM_errorLog("UPLOAD FILE PATH=".$sFilePath,1);
	// If a file with that name already exists.
	if ( is_file( $sFilePath ) )
	{
		$iCounter++ ;
		$sFileName = RemoveExtension( $sOriginalFileName ) . '(' . $iCounter . ').' . $sExtension ;
		$sErrorNumber = '201' ;
	}
	else
	{
		//@@@@@@@@@@ 礭ΥꥵJPEGΤߡ
		$asize = GetImageSize($oFile['tmp_name']);
		if ( ($sExtension=='jpeg' || $sExtension=='jpg') 	
		    && (($asize[0] > $_CONF['max_image_width']) || ($asize[1] > $_CONF['max_image_height'])) ){
			$sizefactor = calcSizefactor($asize[0], $asize[1]);

			$newwidth = (int) ($asize[0] * $sizefactor);
            $newheight = (int) ($asize[1] * $sizefactor);
			$image_dest = @ImageCreateTrueColor($newwidth, $newheight);
            $image_source = imagecreatefromjpeg ($oFile['tmp_name']);
            imagecopyresized ($image_dest, $image_source, 0, 0, 0, 0,
                                  $newwidth, $newheight, $asize[0],$asize[1]);
			imagejpeg($image_dest, $sFilePath);
		}
		else{
			move_uploaded_file( $oFile['tmp_name'], $sFilePath ) ;
		}

		if ( is_file( $sFilePath ) )
		{
			$oldumask = umask(0) ;
			chmod( $sFilePath, 0777 ) ;
			umask( $oldumask ) ;
		}
		
		// Geeklog Japanese changed by Tofuya
		// $sFileUrl = $Config["UserFilesPath"] . $sFileName ;
		$sFileUrl = $Config["UserFilesPath"] .'Image/'. $sFileName ;
		break ;
	}
}

SendResults( $sErrorNumber, $sFileUrl, $sFileName ) ;
?>